---
stages:
  - build
  - test
  - release

variables:
  CLONE_URL: https://gitlab.com/tango-controls/RPM/dsconfig-spec.git 

build-dsconfig:
  stage: build
  # Note that wget is required by `copr-cli download-build` (should be in the image) 
  image: python:3
  before_script:
    - python3 -m venv /venv
    - source /venv/bin/activate
    - python3 -m pip install copr-cli
  script:
    - copr-cli --config $COPR_CONFIG buildscm --clone-url ${CLONE_URL} --commit ${BUILD_COMMIT} ${COPR_PROJECT} 2>&1 | tee copr-build.log 
    - export BUILD_ID=$(awk '/Created builds/ {print $NF}' copr-build.log)
    - copr-cli --config $COPR_CONFIG download-build -d RPMS --chroot epel-8-x86_64 $BUILD_ID
  artifacts:
    paths:
      - RPMS/*/*.rpm
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: never
    - if: '$CI_COMMIT_TAG'
      variables:
        COPR_PROJECT: "@tango-controls/tango"
        BUILD_COMMIT: "$CI_COMMIT_TAG"
    - if: '$CI_COMMIT_BRANCH'
      variables:
        COPR_PROJECT: "@tango-controls/tango-test"
        BUILD_COMMIT: "$CI_COMMIT_SHA"

test-dsconfig-el8:
  stage: test
  image: rockylinux:8
  before_script:
    - dnf install -y epel-release 'dnf-command(copr)'
    - dnf copr -y enable ${COPR_PROJECT}
    # Enabling powertools is required to install boost-python3
    - dnf config-manager --set-enabled powertools
  script:
    - dnf install -y python3-dsconfig
    - json2tango --help
    - xls2json --help
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: never
    - if: '$CI_COMMIT_TAG'
      variables:
        COPR_PROJECT: "@tango-controls/tango"
    - if: '$CI_COMMIT_BRANCH'
      variables:
        COPR_PROJECT: "@tango-controls/tango-test"

upload-dsconfig-srpm:
  stage: release
  image: curlimages/curl:latest
  script:
    - export SRPM_FILENAME=$(basename RPMS/epel-8-x86_64/*.src.rpm)
    - 'curl --fail --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file RPMS/epel-8-x86_64/${SRPM_FILENAME} "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/dsconfig/${CI_COMMIT_TAG}/${SRPM_FILENAME}"'
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
      when: never
    - if: '$CI_COMMIT_TAG'
